#ifndef BSON2KSAT_CONVERTER_H
#define BSON2KSAT_CONVERTER_H

#include "bsoncxx/document/view.hpp"
#include "bsoncxx/array/view.hpp"
#include "bsoncxx/types.hpp"

#include "util/convert.h"
#include "util/ksatinstance.h"
#include "util/bson2ksatClauseConverter.h"

namespace satlab
{
    
namespace types
{

template<typename = KSATinstance, typename = bsoncxx::document::view>
void convert(KSATinstance& ksat, const bsoncxx::document::view& docView)
{
    using CLAUSE = KSATinstance::CLAUSE;
    using CLAUSE_DOC = const bsoncxx::array::element&;
    
    ksat = KSATinstance();
    
    bsoncxx::array::view clauses = docView["clauses"].get_array();
    
    KSATinstance::CLAUSE clause;
    for(auto clauseDoc : clauses)
    {
        convert<>(clause, clauseDoc);
        
        ksat.addClause(clause);
    }
    
    ksat.setId(docView["_id"].get_oid().value.to_string());
}

}

}

#endif // BSON2KSAT_CONVERTER_H
