#ifndef BSON2QBUO_MTRX_H
#define BSON2QBUO_MTRX_H

#include "bsoncxx/document/view.hpp"
#include "bsoncxx/array/view.hpp"
#include "bsoncxx/types.hpp"

#include "util/convert.h"
#include "solver_cxx.h"

#include <iostream>
#include "bsoncxx/json.hpp"

#include <map>
#include <unordered_map>

#include <tuple>

namespace satlab
{
    
namespace types
{

template<typename = qbscxx::QUBO, typename = bsoncxx::document::view>
void convert(qbscxx::QUBO& qubo, const bsoncxx::document::view& docView)
{
    using NODE = std::tuple<int, int>;
    using NODE_INDEX_DICT = std::map<NODE, size_t>;
    
    //qubo = qbscxx::QUBO();
    
    NODE_INDEX_DICT nodeIndexDict;
    
    NODE node1;
    size_t nodeIndex = 0;
    for(auto& entry : docView["qubo"].get_array().value)
    {
        for(auto& nodeView : entry[0].get_array().value)
        {
            node1 = NODE(nodeView[0].get_int32().value,
                         nodeView[1].get_int32().value);
            
            if(nodeIndexDict.find( node1 ) == nodeIndexDict.end())
            {
                nodeIndexDict.emplace(node1, nodeIndex);
                nodeIndex++;
            }
        }
    }
    
    qubo.resize(nodeIndexDict.size());
    for(int i=0; i < nodeIndexDict.size(); i++)
    {
        qubo[i].resize(nodeIndexDict.size());
    }
    
    NODE node2;
    for(auto& entry : docView["qubo"].get_array().value)
    {
        auto coupler = entry[0];
        auto node1doc = coupler[0];
        auto node2doc = coupler[1];
        
        node1 = NODE(node1doc[0].get_int32().value,
                     node1doc[1].get_int32().value);
        
        node2 = NODE(node2doc[0].get_int32().value,
                     node2doc[1].get_int32().value);
        
        size_t nodeIndex1 = nodeIndexDict.at(node1);
        size_t nodeIndex2 = nodeIndexDict.at(node2);
        qbscxx::ENERGY_T energy = entry[1].get_double().value;
        
        qubo[nodeIndex1][nodeIndex2] = energy;
    }
    
    nodeIndexDict.clear();
}

}

}

#endif // BSON2QBUO_MTRX_H
