#ifndef BSON_2_QUBO_COUPLER_H
#define BSON_2_QUBO_COUPLER_H

#include "bsoncxx/document/view.hpp"
#include "bsoncxx/array/view.hpp"
#include "bsoncxx/types.hpp"

#include "util/convert.h"

#include <map>
#include <unordered_map>

#include <tuple>

#include "util/wmis_qubo.h"

namespace satlab
{
    
namespace types
{
    
template<typename = wmis_qubo::COUPLER, typename = bsoncxx::array::view>
void convert(wmis_qubo::COUPLER& coupler, const bsoncxx::array::view& docView)
{
    auto nodes = docView[0].get_array().value;
        
    wmis_qubo::NODE node1(nodes[0][0].get_int32().value,
                          nodes[0][1].get_int32().value);
        
    wmis_qubo::NODE node2(nodes[1][0].get_int32().value,
                          nodes[1][1].get_int32().value);
        
    qbscxx::ENERGY_T energy = docView[1].get_double().value;
    
    coupler = wmis_qubo::COUPLER(node1, node2, energy);
}

}

}

#endif // BSON_2_QUBO_COUPLER_H
