#ifndef MINISAT_RESULT_2_BSON
#define MINISAT_RESULT_2_BSON

#include "util/convert.h"
#include "util/minisatresult.h"
#include "util/ksatModel2bson.h"
#include "util/minisatStats2bson.h"

#include "bsoncxx/document/value.hpp"
#include "bsoncxx/builder/stream/document.hpp"

namespace satlab
{
    
template<typename = bsoncxx::builder::stream::document, typename = MinisatResult>
void convert(bsoncxx::builder::stream::document& builder, const MinisatResult& result)
{
    using ARRAY_BUILDER = bsoncxx::builder::stream::array;
    using DOCUMENT_BUILDER = bsoncxx::builder::stream::document;
    
    builder.clear();
    
    ARRAY_BUILDER model;
    DOCUMENT_BUILDER stats;
    
    convert<>(model, result.getModel());
    convert<>(stats, result.getStats());
    
    builder << "satisfiable" << result.getSatisfiable()
            << "model" << model.view()
            << "stats" << stats.view()
            << "instance" << bsoncxx::oid(result.getInstanceId());
}


}

#endif // MINISAT_RESULT_2_BSON
